<?php
// Version: 0.9; TPortalBlocks

// TPortal searchblock
function TPortal_searchbox()
{
	global $context, $settings, $options, $txt , $scripturl;

	echo '
	<form  accept-charset="', $context['character_set'], '" action="', $scripturl, '?action=search2" method="post" style="padding: 0; text-align: center; margin: 0; margin-bottom: 5px;">
		<br /><input type="text" name="search" value="" style="width: 85%;" /><br />
		<input type="submit" name="submit" value="', $txt[182], '" style="width: 90%; margin: 4px;" /><br /><span class="smalltext">
		<a href="', $scripturl, '?action=search;advanced">', $txt['smf298'], '</a></span>
		<input type="hidden" name="advanced" value="0" />
	</form>';

}

// TPortal onlineblock
function TPortal_onlinebox()
{
	global $context, $settings, $options, $txt;

	echo '
	<span class="smalltext">' , ssi_logOnline() , '</span>';
}

// php blocktype
function TPortal_phpbox()
{
	global $context, $settings, $options, $txt, $scripturl;

	// execute what is in the block, no echoing
	if(!empty($context['TPortal']['phpboxbody']));
		eval($context['TPortal']['phpboxbody']);
}

// an article
function TPortal_articlebox()
{
	global $context, $settings, $options, $txt, $scripturl;

	$story=array();

	if(isset($context['TPortal']['blockarticles'][$context['TPortal']['blockarticle']])){
		$story=$context['TPortal']['blockarticles'][$context['TPortal']['blockarticle']];

		echo '
		<div style="_height: 1%; overflow: hidden; padding: 4px;">';

		// any options for author and date?
		if(isset($story['options']['author']) || $story['is_boardnews'])
			echo '<span class="smalltext">' , $txt['tp-author'] , ': <b>' , $story['poster']['link'] , '</b></span><br />';
		if(isset($story['options']['date']) || $story['is_boardnews'])
			echo '<span class="smalltext"><br />' , $story['time'] , '</span><br />';
		// ..and for views and ratings , even comments?
		$opts=array();
		if(isset($story['options']['views']) || $story['is_boardnews'])
			$opts[] = '<span class="smalltext">' . $txt['tp-views'] . ': ' . $story['views'] . ' </span>';
		if(isset($story['options']['comments']) || $story['is_boardnews']){
			if($story['is_boardnews'] && ($story['comments']>1 || $story['comments']==0))
				$what=$txt[110];
			elseif($story['is_boardnews'] && $story['comments']==1)
				$what=$txt[146];
			else
				$what=$txt['tp-comments'];

			$opts[] = '<span class="smalltext">' . $what . ': ' . $story['comments'] . ' </span>';
		}
		if(isset($story['options']['rating']))
			$opts[] = '<span class="smalltext">' . $txt['tp-ratingaverage'] . ' ' . $story['rating_average'] . ' (' . $story['rating_votes'] . ' ' . $txt['tp-ratingvotes'] . ') </span>';

		echo implode("<br />",$opts);

		// render the text
		echo '
			<div style="overflow: hidden; _height: 1%;' , (isset($story['options']['author']) || isset($story['options']['date']) || $story['is_boardnews']) ? ' margin-top: 1ex;' : '' , '">';

		// any category icon?
		if(!empty($story['category']))
			echo $story['category'];

		// set some height to articles too...
		echo '
				<div style="line-height: 1.3em;">';
		// use a intro when not single page mode?
		if($context['TPortal']['front_type']!='singlepage'){
			// use intro!
			if($story['use_intro']=='1' && !isset($context['TPortal']['show_single_page'])){
				if($story['is_php']){
					eval($story['body']);
				}
				else{
					echo $story['introtext'];
					echo '
					<div class="smalltext" style="margin-top: 1ex; font-weight: bold;"><a href="' .$story['href']. '">'.$txt['tp-readmore'].'</a></div>';
				}
			}
			else{
				if($story['is_php'])
					eval($story['body']);
				else
					echo $story['body'];
			}
		}
		else{
			if($story['is_php'])
				eval($story['body']);
			else
				echo $story['body'];
		}

		echo '
				</div>
			</div>';

		// give 'em a edit link? :)
		if(allowedTo('tp_articles') && !$story['is_boardnews'])
			echo '
			<div class="smalltext" style="margin: 1ex 1ex 0 0;">
				<a href="' , $scripturl , '?action=tpadmin;sa=editarticle' , $story['id'] , '">[' , $txt['tp-editarticle'] , ']</a>
				<a href="' , $scripturl , '?action=tpadmin;sa=editarticle' , $story['id'] , ';visualopts">[' , $txt['tp-editarticle2'] , ']</a>
			</div>';
		echo '
		</div>';
	}
}

// php blocktype
function TPortal_scriptbox()
{
	global $context, $settings, $options, $txt;

    echo $context['TPortal']['scriptboxbody'];
}

// TPortal recent topics block
function TPortal_recentbox()
{
	global $context, $settings, $options, $txt , $modSettings;

    // is it a number?
	if(!is_numeric($context['TPortal']['recentboxnum']))
		$context['TPortal']['recentboxnum']='10';

	// leave out the recycle board, if any
	if(isset($modSettings['recycle_board']))
		$bb=array($modSettings['recycle_board']);
	else
		$bb=array();

	$what=ssi_recentTopics($num_recent = $context['TPortal']['recentboxnum'], $bb, $output_method = 'array');
	// Output the topics
	$counter=1; $cmax=count($what);
	echo '
	<div style="width: 100%; ' , $context['TPortal']['recentboxscroll']==1 ? 'overflow: auto; height: 20ex;' : '' , '">';
	foreach($what as $w){
		echo '
		<div class="smalltext"><a href="'.$w['href'].'">'.$w['short_subject'].'</a></div>
		<div class="smalltext">', $txt[525], ' <b>', $w['poster']['link'], '</b></div>
		<div class="smalltext">';
		if(!$w['new'])
			echo '<a href="'.$w['href'].'"><img border="0" src="'.$settings['images_url'].'/'.$context['user']['language'].'/new.gif" alt="new" /></a> ';

		echo '['.$w['time'].']
		</div>';

		if($counter != $cmax)
			echo '<hr />';
		$counter++;
	}
	echo '
	</div>';
}

// TPortal categories
function TPortal_catmenu()
{
	global $context, $settings, $options , $scripturl;

	if(isset($context['TPortal']['menu']) && !empty($context['TPortal']['menu'])){
		echo '
	<div style="width: 100%; overflow: hidden;">';
		foreach($context['TPortal']['menu'] as $cn){
			echo str_repeat("&nbsp;&nbsp;", ($cn['sub']+1));
			if((!isset($cn['icon']) || (isset($cn['icon']) && $cn['icon']=='')) && $cn['type']!='head' && $cn['type']!='spac'){
				echo '<img src="'.$settings['images_url'].'/TPdivider2.gif" alt="" />&nbsp;';
			}
			elseif(isset($cn['icon']) && $cn['icon']!='' && $cn['type']!='head' && $cn['type']!='spac'){
				echo '<img alt="*" src="'.$cn['icon'].'" />&nbsp;';
			}
			switch($cn['type']){
				case 'cats' :
					echo '<a href="'. $scripturl. '?cat='.$cn['IDtype'].'" ' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '>'.$cn['name'].'</a><br />';
					break;
				case 'arti' :
					echo '<a href="'. $scripturl. '?page='.$cn['IDtype'].'"' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '>'.$cn['name'].'</a><br />';
					break;
				case 'link' :
					echo '<a href="'.$cn['IDtype'].'"' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '>'.$cn['name'].'</a><br />';
					break;
				case 'head' :
					echo '<b>'.$cn['IDtype'].'</b><br />';
					break;
				case 'spac' :
					echo '<br />';
					break;
				default :
					echo '<a href="'.$cn['IDtype'].'"' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '>'.$cn['name'].'</a><br />';
					break;
			}
		}
		echo '
	</div>';
	}
}

// TPortal side bar, left or right.
function TPortal_sidebar($side)
{
	global $context , $scripturl, $settings, $language , $txt;

	for ($i = 0, $n = count($context['TPortal'][$side . 'block']['blocks']); $i < $n; $i += 1){
		$block =& $context['TPortal'][$side . 'block']['blocks'][$i];
		$theme = $block['frame'] == 'theme';

		// check if a language title string exists
		$newtitle = TPgetlangOption($block['lang'], $context['user']['language']);
		if(!empty($newtitle))
			$block['title'] = $newtitle;

		$use=true;
		// special title links and variables for special types
		switch($block['type']){
			case 'searchbox':
				$mp='<a href="'.$scripturl.'?action=search">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'onlinebox':
				$mp='<a href="'.$scripturl.'?action=who">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'userbox':
				if($context['user']['is_logged'])
					$mp='<a href="'.$scripturl.'?action=profile;u='.$context['user']['id'].'">'.$block['title'].'</a>';
				else
					$mp='<a href="'.$scripturl.'?action=login">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'statsbox':
				$mp='<a href="'.$scripturl.'?action=stats">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'shoutbox':
				$mp='<a href="'.$scripturl.'?action=tpmod;sa=shoutbox">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'recentbox':
				$mp='<a href="'.$scripturl.'?action=recent">'.$block['title'].'</a>';
				$c=explode(',' ,$block['body']);
				$context['TPortal']['recentboxnum']=$c[0];
				if(isset($c[1]))
					$context['TPortal']['recentboxscroll']=$c[1];
				else
					$context['TPortal']['recentboxscroll']=0;
				break;
			case 'scriptbox':
				$context['TPortal']['scriptboxbody']=$block['body'];
				break;
			case 'phpbox':
				$context['TPortal']['phpboxbody']=$block['body'];
				break;
			case 'ssi':
				$context['TPortal']['ssifunction']= $block['body'];
				break;
			case 'module':
				$context['TPortal']['moduleblock']= $block['body'];
				break;
			case 'themebox':
				$context['TPortal']['themebox_path']= $block['body'];
				break;
			case 'newsbox':
				if($context['random_news_line']=='')
					$use=false;
				break;
			case 'articlebox':
				$context['TPortal']['blockarticle']= $block['body'];
				break;
			case 'rss':
				$context['TPortal']['rss']= $block['body'];
				$context['TPortal']['rss_notitles']= $block['var2'];
				break;
			case 'categorybox':
				$context['TPortal']['blocklisting']= $block['body'];
				$context['TPortal']['blocklisting_height']= $block['var1'];
				break;
		}
		if($use)
		{
			echo
	'<div', (($theme || $block['frame']=='frame') ? ' class="tborder"' : ''), ' style="margin-bottom: 2px;">';

			if ($theme || $block['frame'] == 'title'){
				echo '
		<div class="catbg" style="padding: 4px 5px 5px 10px; font-weight: bold;"><div class="catbg_imgleft"><div class="catbg_imgright">';
				if($block['visible']=='' || $block['visible']=='1')
					echo '<a href="javascript: void(0); return false" onclick="toggle(\''.$block['id'].'\'); return false"><img id="blockcollapse'.$block['id'].'" style="margin: 0;" align="right" src="'.$settings['images_url'].'/' , ((isset($context['TPortal']['upshrinkblocks'][$block['id']]) && $context['TPortal']['upshrinkblocks'][$block['id']]==1) || !isset($context['TPortal']['upshrinkblocks'][$block['id']])) ? 'collapse' : 'expand' , '.gif" border="0" alt="" /></a>';

				// can you edit the block?
				if($block['can_edit'] && !$context['TPortal']['blocks_edithide'])
					echo '<a href="',$scripturl,'?action=tpmod;sa=editblock'.$block['id'].';sesc='.$context['session_id'].'"><img style="margin-right: 4px;" border="0" align="right" src="'.$settings['images_url'].'/tp-edit.gif" alt="" /></a>';
				elseif($block['can_manage'] && !$context['TPortal']['blocks_edithide'])
					echo '<a href="',$scripturl,'?action=tpadmin;blockedit'.substr($side,0,1).'='.$block['id'].';sesc='.$context['session_id'].'"><img border="0" style="margin-right: 4px;" align="right" src="'.$settings['images_url'].'/tp-edit.gif" alt="" /></a>';

				echo $block['title'],'
		</div></div></div>';
			}
			else
			{
				if(($block['visible']=='' || $block['visible']=='1') || $block['frame']!='frame'){
					echo '
		<div style="padding: 4px 5px 5px 10px;">';
				if($block['visible']=='' || $block['visible']=='1')
					echo '<a href="javascript: void(0); return false" onclick="toggle(\''.$block['id'].'\'); return false"><img id="blockcollapse'.$block['id'].'" style="margin: 0;" align="right" src="'.$settings['images_url'].'/' , ((isset($context['TPortal']['upshrinkblocks'][$block['id']]) && $context['TPortal']['upshrinkblocks'][$block['id']]==1) || !isset($context['TPortal']['upshrinkblocks'][$block['id']])) ? 'collapse' : 'expand' , '.gif" border="0" alt="" /></a>';

				// can you edit the block?
				if($block['can_edit'] && !$context['TPortal']['blocks_edithide'])
					echo '<a href="',$scripturl,'?action=tpmod;sa=editblock'.$block['id'].';sesc='.$context['session_id'].'"><img style="margin-right: 4px;" border="0" align="right" src="'.$settings['images_url'].'/tp-edit.gif" alt="" /></a>';
				elseif($block['can_manage'] && !$context['TPortal']['blocks_edithide'])
					echo '<a href="',$scripturl,'?action=tpadmin;blockedit'.substr($side,0,1).'='.$block['id'].';sesc='.$context['session_id'].'"><img border="0" style="margin-right: 4px;" align="right" src="'.$settings['images_url'].'/tp-edit.gif" alt="" /></a>';

						echo '&nbsp;
		</div>';
				}
			}
			echo '
		<div', (($theme || $block['frame']=='frame') ? ' class="windowbg"' : ''), ' style="padding:' , (($theme || $block['frame']=='frame') ? '4' : '0') , 'px; ', (isset($context['TPortal']['upshrinkblocks'][$block['id']]) && $context['TPortal']['upshrinkblocks'][$block['id']]==0) ? 'display: none;' : ''  , '" id="block'.$block['id'].'">';

			$func = 'TPortal_' . $block['type'];
			if (function_exists($func))
				$func();
			else
				echo doUBBC($block['body']);

			echo '</div></div>';
		}
	}
	// the upshrink routine for blocks
	$tid=time();

	echo '
			<script language="Javascript" type="text/javascript">
				function toggle( targetId )
				{
					var state = 0;
					var blockname = "block" + targetId;
					var blockimage = "blockcollapse" + targetId;

					if ( document.getElementById ) {
						target = document.getElementById( blockname );
						if ( target.style.display == "none" ) {
							target.style.display = "";
							state = 1;
						}
						else {
							target.style.display = "none";
							state = 0;
						}

						document.getElementById( blockimage ).src = smf_images_url + (state ? "/collapse.gif" : "/expand.gif");
						var tempImage = new Image();
						tempImage.src = "'.$scripturl.'?action=tpmod;upshrink=" + targetId + ";state=" + state + ";" + (new Date().getTime());

					}
				}
			</script>';
}

// TPortal leftblocks
function TPortal_leftbar()
{
	TPortal_sidebar('left');
}

// TPortal centerbar
function TPortal_centerbar()
{
	TPortal_sidebar('center');
}

// TPortal rightbar
function TPortal_rightbar()
{
	TPortal_sidebar('right');
}

// Tportal userbox
function TPortal_userbox()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings;

	$bullet = '<img src="'.$settings['images_url'].'/TPdivider.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet2 = '<img src="'.$settings['images_url'].'/TPdivider2.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet3 = '<img src="'.$settings['images_url'].'/TPdivider3.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet4 = '<img src="'.$settings['images_url'].'/tpgoto.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet5 = '<img src="'.$settings['images_url'].'/tpmodule2.gif" alt="" border="0" style="margin:0 2px 0 0;" />';

	echo'
	<div class="smalltext">';

	if (!empty($context['user']['avatar']) && isset($context['TPortal']['userbox']['avatar']))
		echo $context['user']['avatar']['image'] . '<br />';

	// If the user is logged in, display stuff like their name, new messages, etc.
	if ($context['user']['is_logged']){
		echo '<span class="normaltext">', $txt['hello_member'], ' <b>', $context['user']['name'], '</b></span>';

		// Only tell them about their messages if they can read their messages!
		if ($context['allow_pm']){
			echo '<br />'.$bullet.'<a href="', $scripturl, '?action=pm">' .$txt['tp-pm'].' ', $context['user']['messages'], '</a>';
			if($context['user']['unread_messages']>0)
				echo '<br />'.$bullet.'<a style="font-weight: bold; " href="', $scripturl, '?action=pm">' .$txt['tp-pm2'].' ',$context['user']['unread_messages'] , '</a>';
		}
		// Are there any members waiting for approval?
		if (!empty($context['unapproved_members']))
			echo '<br />'.$bullet.'<a href="', $scripturl, '?action=viewmembers;sa=browse;type=approve">'.$txt['tp_unapproved_members'].'<b> '. $context['unapproved_members']  . '</b></a>';

		if(isset($context['TPortal']['userbox']['unread'])){
			echo '<br />'.$bullet.'<a href="', $scripturl, '?action=unread">' .$txt['tp-unread'].'</a>
				<br />'.$bullet.'<a href="', $scripturl, '?action=unreadreplies">'.$txt['tp-replies'].'</a>
				<br />'.$bullet.'<a href="', $scripturl, '?action=profile;u='.$context['user']['id'].';sa=showPosts">'.$txt['tp-showownposts'].'</a>';
		}

		// Is the forum in maintenance mode?
		if ($context['in_maintenance'] && $context['user']['is_admin'])
			echo '<br /><b>' .$bullet.$txt['tp_maintenace']. '</b>';
		// Show the total time logged in?
		if (!empty($context['user']['total_time_logged_in']) && isset($context['TPortal']['userbox']['logged'])){
			echo '<br />'.$bullet.$txt['tp-loggedintime'] . ' ';
			echo '<br />'.$context['user']['total_time_logged_in']['days'] . $txt['tp-acronymdays'];
			echo $context['user']['total_time_logged_in']['hours'] . $txt['tp-acronymhours'];
			echo $context['user']['total_time_logged_in']['minutes'] .$txt['tp-acronymminutes'];
		}
		if(isset($context['TPortal']['userbox']['time'])){
			echo '<br />'.$bullet. $context['current_time'];
		}
	}
	// Otherwise they're a guest - so politely ask them to register or login.
	else{
		echo '
	', $txt['welcome_guest'], '<br />
	', $context['current_time'], '<br />
	<form action="', $scripturl, '?action=login2" method="post" >
		<input type="text" name="user" size="10" /> <input type="password" name="passwrd" size="10" />
        <select name="cookielength">
			<option value="60">', $txt['smf53'], '</option>
			<option value="1440">', $txt['smf47'], '</option>
			<option value="10080">', $txt['smf48'], '</option>
			<option value="302400">', $txt['smf49'], '</option>
			<option value="-1" selected="selected">', $txt['smf50'], '</option>
		</select>
        <input type="submit" value="', $txt[34], '" /><br />
        ', $txt['smf52'], '
	</form>';
	}
	echo '</div>';
}

// TPortal themebox
function TPortal_themebox()
{
	global $context, $settings, $options, $scripturl, $txt, $modSettings, $user_info;

	$temaid=explode(',',$context['TPortal']['temaer']);
	$temanavn=explode(',',$context['TPortal']['temanames']);
	$temapaths=explode(',',$context['TPortal']['temapaths']);
	if(isset($context['TPortal']['querystring']))
		$tp_where=$context['TPortal']['querystring'];
	else
		$tp_where='action=forum;';

	if($tp_where!='')
		$tp_where .=';';

	// remove multiple theme=x in the string.
		$tp_where=preg_replace("'theme=[^>]*?;'si", "", $tp_where);

	 if(sizeof($temaid)>1){
        echo '<form name="jumpurl1" onSubmit="return jumpit()" style="padding: 0; margin: 0; text-align: center;">
					<select style="width: 100%; margin: 5px 0px 5px 0px;" size="1" name="jumpurl2" onChange="check(this.value)">';
         for($a=0 ; $a<(sizeof($temaid)) ; $a++){
                echo '<option value="'.$temaid[$a].'" ', $settings['theme_id'] == $temaid[$a] ? 'selected' : '' ,'>'.substr($temanavn[$a],0,20).'</option>';
         }
         echo '</select><br /><input style="margin: 5px 0px 5px 10px;" type="button" value="'.$txt['tp-changetheme'].'" onClick="jumpit()">
		 			<input type="hidden" value="'.htmlspecialchars($scripturl . '?'.$tp_where.'theme='.$settings['theme_id']).'" name="jumpurl3">
		 			<div style="width: 95%; overflow: hidden;">
						<img align="center" src="'.$settings['images_url'].'/thumbnail.gif" alt="" id="chosen" name="chosen"  />
					</div>
				</form>
                   <script type="text/javascript" language="Javascript">
			var themepath=new Array()';
         for($a=0 ; $a<(sizeof($temaid)) ; $a++){
			 echo '
			    themepath['.$temaid[$a].'] = "'.$temapaths[$a].'/thumbnail.gif"
				';
		 }

		echo '
		 function jumpit(){
                          window.location=document.jumpurl1.jumpurl3.value
                          return false
                       }
                   </script>
					   <script type="text/javascript">
        function check(icon)
       {

		document.chosen.src= themepath[icon]
		document.jumpurl1.jumpurl3.value = \'' . $scripturl . '?'. $tp_where.'theme=\' + icon
       }
</script>';
	}
	else
		echo $txt['tp-nothemeschosen'];
}

// TPortal newsbox
function TPortal_newsbox()
{
        global $context, $settings, $options, $scripturl, $txt, $modSettings;

        // Show a random news item? (or you could pick one from news_lines...)
        if (!empty($settings['enable_news']))
                echo ' <div style="padding: 5px;" >', $context['random_news_line'], '</div>';
}

// TPortal stats box
function TPortal_statsbox()
{
       global $context, $settings, $options, $scripturl, $txt, $modSettings;

		$bullet = '<img src="'.$settings['images_url'].'/TPdivider.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
		$bullet2 = '<img src="'.$settings['images_url'].'/TPdivider2.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
        echo'<div class="smalltext" style="font-family: verdana, arial, sans-serif;">';

       if(isset($context['TPortal']['userbox']['stats']))
	   // members stats
            echo '
                 <img src="'.$settings['images_url'].'/icons/members.gif" style="margin: 0;" align="bottom" alt="" />
                 <a href="'.$scripturl.'?action=mlist"><b>'.$txt[19].'</b></a>
                 <br />'.$bullet.$txt[488].': ' , isset($modSettings['memberCount']) ? $modSettings['memberCount'] : $modSettings['totalMembers'] , '
                 <br />'.$bullet.$txt['tp-latest']. ': <a href="', $scripturl, '?action=profile;u=', $modSettings['latestMember'], '"><b>', $modSettings['latestRealName'], '</b></a>';
       if(isset($context['TPortal']['userbox']['stats_all']))
	   // more stats
            echo '
                  <hr /><img src="'.$settings['images_url'].'/icons/info.gif" style="margin: 0;" align="bottom" alt="" />
                 <a href="'.$scripturl.'?action=stats"><b>'.$txt['tp-stats'].'</b></a>
                 <br />'.$bullet.$txt[489].': '.$modSettings['totalMessages']. '
				  <br />'.$bullet. $txt[490].': '.$modSettings['totalTopics']. '
				  <br />'.$bullet.$txt['tp-mostonline-today'].': '.$modSettings['mostOnlineToday'].'
				  <br />'.$bullet.$txt['tp-mostonline'].': '.$modSettings['mostOnline'].'<br />
					  ('.timeformat($modSettings['mostDate']).')
				  ';

       if(isset($context['TPortal']['userbox']['online'])){
	   // add online users
            echo '<hr /><img src="'.$settings['images_url'].'/icons/online.gif" style="margin: 0;" align="bottom" alt="" />
                 <a href="'.$scripturl.'?action=who"><b>'.$txt[158].'</b></a><br />';

            $online = ssi_whosOnline('array');
	   echo $bullet.$txt['tp-users'].': '.$online['num_users'];
	   echo '<br />'.$bullet.$txt['tp-guests'].': '.$online['guests'];
	   echo '<br />'.$bullet.$txt['tp-total'].': '.$online['total_users'].'<hr />
			<div style="width: 100%; ' , $online['num_users']>14 ? 'height: 23ex;overflow: auto;' : '' ,'">';

      foreach($online['users'] as $user){
		echo $bullet2 , $user['hidden'] ? '<i>' . $user['link'] . '</i>' : $user['link'];
		echo '<br />';
	   }
		echo '</div>';
         }
	echo '</div>';
}

// TPortal shoutbox
function TPortal_shoutbox()
{
        global $context, $settings, $options, $scripturl, $txt, $modSettings;

        // Show the shoutbox, takes settings from tpadmin
       if(isset($context['TPortal']['querystring']))
             $tp_where=$context['TPortal']['querystring'];
       else
              $tp_where='';

       if(!isset($context['TPortal']['shoutbox']))
             $context['TPortal']['shoutbox']='';

		if($context['TPortal']['shoutbox_usescroll']=='1')
			echo '
			<div id="marqueecontainer" onmouseover="copyspeed=pausespeed" onmouseout="copyspeed=marqueespeed">
				<div id="vmarquee" class="smalltext" style="text-align: left;position: absolute; width: 98%;">
					'.$context['TPortal']['shoutbox'].'
				</div>
			</div>';
		else
			echo '
				<table cellpadding="0" align="center" width="100%" cellspacing="0" style="table-layout: fixed;">
					<tr><td><div class="smalltext" style="width: 99%; height: '.$context['TPortal']['shoutbox_height'].'px; overflow: auto;">', $context['TPortal']['shoutbox'], '</div></td>
					</tr>
				</table>';

       // show archives
       if($context['TPortal']['show_shoutbox_archive']>0){
			echo '
			<div style="text-align: center; margin-top: 5px; " class="smalltext"><a href="',$scripturl,'?action=tpmod;sa=shoutbox;shouts='.$context['TPortal']['show_shoutbox_archive'].'">',$txt['tp-showshouts'],' ',$context['TPortal']['show_shoutbox_archive'],'</a></div>';
       }
       echo '
       <form  accept-charset="', $context['character_set'], '" class="smalltext" style="padding: 0; margin: 0; margin-top: 8px; text-align: center;" name="tp-shoutbox" action="'.$scripturl.'?action=tpmod;id=shout" method="post">';
       if(($context['TPortal']['guest_shout']) || (!$context['TPortal']['guest_shout'] && !$context['user']['is_guest'])){
             echo '<textarea class="smalltext" name="tp-shout" style="width: 80%;margin-top: 1ex; height: 50px;" wrap="auto"></textarea><br />';
         	echo '<input style="margin-top: 4px;" class="smalltext" type="submit" name="shout_send" value="'.$txt['shout!'].'">';
		}
       if($context['user']['is_guest'] && $context['TPortal']['guest_shout'])
             echo '<br /><input style="margin-top: 4px;" size="20" class="smalltext" type="text" name="tp-shout-name" value="'.$txt['tp-guest'].'">';
       else
             echo '<input type="hidden" name="tp-shout-name" value="'.$context['user']['name'].'">
             ';

       echo '<input name="tp-shout-url" type="hidden" value="'.htmlspecialchars($tp_where).'"><input type="hidden" name="sc" value="', $context['session_id'], '" />
       </form>';
}

// TPortal ssi box
function TPortal_ssi()
{
       global $context, $settings, $options, $scripturl, $txt, $modSettings;
       echo '
	<div style="padding: 5px;" class="smalltext">';
       if($context['TPortal']['ssifunction']=='recentpoll')
           ssi_recentPoll();
       elseif($context['TPortal']['ssifunction']=='toppoll')
           ssi_topPoll();
       elseif($context['TPortal']['ssifunction']=='topboards')
           ssi_topBoards();
       elseif($context['TPortal']['ssifunction']=='topposters')
           ssi_topPoster(5);
       elseif($context['TPortal']['ssifunction']=='topreplies')
           ssi_topTopicsReplies();
       elseif($context['TPortal']['ssifunction']=='topviews')
           ssi_topTopicsViews();
       elseif($context['TPortal']['ssifunction']=='calendar')
          ssi_todaysCalendar();

       echo '
    </div>';
}
// TPortal module
function TPortal_module()
{
       global $context, $settings, $options, $scripturl, $txt, $modSettings;

      switch($context['TPortal']['moduleblock']){
		case 'dl-stats';
			dl_recentitems('8','date','echo');
			break;
		case 'dl-stats2';
			dl_recentitems('8','downloads','echo');
			break;
		case 'dl-stats3';
			dl_recentitems('8','views','echo');
			break;
		case 'dl-stats4';
			$it=array();
			$it=dl_recentitems('1','date','array');
			if(sizeof($it)>0){
				foreach($it as $item){
					echo '
					<img src="'.$item['icon'].'" align="right" style="margin-left: 4px; " alt="" />
						<a href="'.$item['href'].'"><b>'.$item['name'].'</b></a>
						<p class="smalltext">'.$txt['tp-uploadedby'].' <b>'.$item['author'].'</b> <br />( '.$item['date'].')<br />
						'.$txt['tp-downloads'].'/'.$txt['tp-itemviews'].': <b>'.$item['downloads'].' / '.$item['views'].'</b></p>';
				}
			}
			break;
		case 'dl-stats5';
			$it=array();
			$it=dl_recentitems('1','downloads','array');
			if(sizeof($it)>0){
				foreach($it as $item){
					echo '
					<img src="'.$item['icon'].'" align="right" style="margin-left: 4px; " alt="" />
						<a href="'.$item['href'].'"><b>'.$item['name'].'</b></a>
						<p class="smalltext">'.$txt['tp-uploadedby'].' <b>'.$item['author'].'</b> <br />( '.$item['date'].')<br />
						'.$txt['tp-downloads'].'/'.$txt['tp-itemviews'].': <b>'.$item['downloads'].' / '.$item['views'].'</b></p>';
				}
			}
			break;
		case 'dl-stats6';
			$it=array();
			$it=dl_recentitems('1','views','array');
			if(sizeof($it)>0){
				foreach($it as $item){
					echo '
					<img src="'.$item['icon'].'" align="right" style="margin-left: 4px; " alt="" />
						<a href="'.$item['href'].'"><b>'.$item['name'].'</b></a>
						<p class="smalltext">'.$txt['tp-uploadedby'].' <b>'.$item['author'].'</b> <br />( '.$item['date'].')<br />
						'.$txt['tp-downloads'].'/'.$txt['tp-itemviews'].': <b>'.$item['downloads'].' / '.$item['views'].'</b></p>';
				}
			}
			break;
		case 'art-recent';
			$it=array();
			$it=art_recentitems('5','date');
			if(sizeof($it)>0){
				foreach($it as $item){
					echo '<span class="smalltext"><a title="'.$item['date'].'" href="'.$scripturl.'?page='.$item['id'].'">'.$item['subject'].'</a>
						</span><br />';
				}
			}
			break;
		case 'art-views';
			$it=array();
			$it=art_recentitems('5','views');
			if(sizeof($it)>0){
				foreach($it as $item){
					echo '<span class="smalltext"><a title="'.$item['views'].' '.$txt['tp-views'].'" href="'.$scripturl.'?page='.$item['id'].'">'.$item['subject'].'</a>
						</span><br />';
				}
			}
			break;
		case 'art-comments';
			$it=array();
			$it=art_recentitems('5','comments');
			if(sizeof($it)>0){
				foreach($it as $item){
					echo '<span class="smalltext"><a title="'.$item['comments'].'" href="'.$scripturl.'?page='.$item['id'].'">'.$item['subject'].'</a>
						('.$item['comments'].')<br /></span>';
				}
			}
			break;
     }
}
// Tportal RSS block
function TPortal_rss()
{
        global $context, $settings, $options, $scripturl, $txt, $modSettings;

        echo '<div style="padding: 5px;" class="smalltext">' , TPparseRSS() , '</div>';
}

// Tportal sitemap menu
function TPortal_sitemap()
{
        global $context, $settings, $options, $scripturl, $txt, $modSettings;

		$current='';
        // check where we are
        if(isset($_GET['action']) && $_GET['action']=='tpmod'){
			if(isset($_GET['dl']))
				$current='dl';
			elseif(isset($_GET['link']))
				$current='link';
			elseif(isset($_GET['show']))
				$current='show';
			elseif(isset($_GET['team']))
				$current='team';
			else
				$current='';
        }
         echo '
	<div class="tborder">
		<ul style="margin: 0; padding: 0; list-style: none;" class="sitemap">';
		if($context['TPortal']['show_download']=='1')
			echo '<li><a class="sitemap_header' , $current=='dl' ? '_active' : '' , '" href="'.$scripturl.'?action=tpmod;dl"><img src="',$settings['images_url'],'/tpmodule2.gif" border="0" alt="" /> '.$txt['tp-dldownloads'].'</a></li>';

		if($context['TPortal']['show_gallery']=='1')
			echo '<li><a class="sitemap_header' , $current=='show' ? '_active' : '' , '" href="'.$scripturl.'?action=tpmod;show"><img src="',$settings['images_url'],'/tpmodule2.gif" border="0" alt="" /> '.$txt['tp-admin15'].'</a></li>';
		if($context['TPortal']['show_linkmanager']=='1')
			echo '<li><a class="sitemap_header' , $current=='link' ? '_active' : '' , '" href="'.$scripturl.'?action=tpmod;link"><img src="',$settings['images_url'],'/tpmodule2.gif" border="0" alt="" /> '.$txt['tp-admin13'].'</a></li>';
		if($context['TPortal']['show_teampage']=='1')
			echo '<li><a class="sitemap_header' , $current=='team' ? '_active' : '' , '" href="'.$scripturl.'?action=tpmod;team"><img src="',$settings['images_url'],'/tpmodule2.gif" border="0" alt="" /> '.$txt['tp-admin17'].'</a></li>';

		if(!empty($context['TPortal']['sitemap']) && !empty($context['TPortal']['menu'])){
			foreach($context['TPortal']['menu'] as $cn){
				// check if we can find the link on current tpage
				$catclass = 'sitemap_header';
				if($cn['type']=='cats'){
					if(is_int(strpos($context['TPortal']['querystring'],'cat='.$cn['IDtype'])))
						$catclass .= '_active';
				}
				elseif($cn['type']=='arti'){
					if(is_int(strpos($context['TPortal']['querystring'],'page='.$cn['IDtype'])))
						$catclass .= '_active';
				}
				elseif($cn['type']=='link'){
					if(!empty($context['TPortal']['querystring']))
						$qs=$scripturl.'?'.$context['TPortal']['querystring'];
					else
						$qs=$scripturl;

					if($qs==$cn['IDtype'])
						$catclass .= '_active';
					else
						$catclass .= '';
				}

				if($cn['sitemap']=='1'){
             		switch($cn['type']){
                			case 'cats' :
                    			echo '<li><a class="' , $catclass ,'" href="'. $scripturl. '?cat='.$cn['IDtype'].'" ' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '><img src="',$settings['images_url'],'/TPdivider.gif" border="0" alt="" /> '.$cn['name'].'</a></li>';
                    			break;
                			case 'arti' :
                    			echo '<li><a class="' , $catclass ,'" href="'. $scripturl. '?page='.$cn['IDtype'].'"' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '><img src="',$settings['images_url'],'/TPdivider.gif" border="0" alt="" /> '.$cn['name'].'</a></li>';
                    			break;
                			case 'link' :
                    			echo '<li><a class="' , $catclass ,'" href="'.$cn['IDtype'].'"' , $cn['newlink']=='1' ? 'target="_blank"' : '' , '><img src="',$settings['images_url'],'/TPdivider.gif" border="0" alt="" /> '.$cn['name'].'</a></li>';
                    			break;
             		}
				}
			}
		}
         echo '</ul></div>';
 }

 // Tportal permissions overview
function TPortal_admin()
{
        global $context, $settings, $options, $scripturl, $txt, $modSettings;

         echo '<div style="padding: 5px;" class="smalltext"><p style="margin: 0; padding: 0 0 .5ex 0;">';

	$bullet = '<img src="'.$settings['images_url'].'/TPdivider.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet2 = '<img src="'.$settings['images_url'].'/TPdivider2.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet3 = '<img src="'.$settings['images_url'].'/TPdivider3.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet4 = '<img src="'.$settings['images_url'].'/tpgoto.gif" alt="" border="0" style="margin:0 2px 0 0;" />';
	$bullet5 = '<img src="'.$settings['images_url'].'/tpmodule2.gif" alt="" border="0" style="margin:0 2px 0 0;" />';

		// admin parts etc.
         if(!isset($context['TPortal']['can_submit_article']))
            $context['TPortal']['can_submit_article']=0;
		// do not show if none is availalable
		if($context['TPortal']['can_submit_article']==1 || allowedTo(array('tp_dlupload','tp_dlmanager','tp_settings','tp_articles','tp_blocks','tp_linkmanager','tp_teampage','tp_gallery')))
		{
				echo '<img src="'.$settings['images_url'].'/tpoptions.gif" style="margin: 0;" align="bottom" alt="" />
			      <b>'.$txt['tp-tools'].'</b></p>';
              	// can we submit an article?
             	if($context['TPortal']['can_submit_article']==1 && !allowedTo('tp_articles'))
                       echo $bullet4.'<a href="', $scripturl, '?action=tpmod;sa=submitarticle">' . $txt['tp-submitarticle']. '</a><br />';

				// upload a file?
             	if(allowedTo('tp_dlupload') || allowedTo('tp_dlmanager'))
                       echo $bullet4.'<a href="', $scripturl, '?action=tpmod;dl=upload">' . $txt['permissionname_tp_dlupload']. '</a><br />';

				// tpadmin checks
				if (allowedTo('tp_settings'))
					echo $bullet4.'<a href="' . $scripturl . '?action=tpadmin;sa=settings">' . $txt['permissionname_tp_settings'] . '</a><br />';
				if (allowedTo('tp_blocks'))
					echo $bullet4.'<a href="' . $scripturl . '?action=tpadmin;sa=blocks">' . $txt['permissionname_tp_blocks'] . '</a><br />';
				if (allowedTo('tp_articles'))
				{
					echo $bullet4.'<a href="' . $scripturl . '?action=tpadmin;sa=articles">' . $txt['permissionname_tp_articles'] . '</a><br />';
					// any submissions?
					if($context['TPortal']['submitcheck']['articles']>0)
						echo $bullet4.$bullet3.'<a href="' . $scripturl . '?action=tpadmin;sa=submission"><b>' . $context['TPortal']['submitcheck']['articles'] . ' ' .$txt['tp-articlessubmitted'] . '</b></a><br />';
				}
				if (allowedTo('tp_dlmanager'))
				{
					echo $bullet4.'<a href="' . $scripturl . '?action=tpmod;dl=admin">' . $txt['permissionname_tp_dlmanager'] . '</a><br />';
					// any submissions?
					if($context['TPortal']['submitcheck']['uploads']>0)
						echo $bullet4.$bullet3.'<a href="' . $scripturl . '?action=tpmod;dl=adminsubmission"><b>' . $context['TPortal']['submitcheck']['uploads'] . ' ' .$txt['tp-dluploaded'] . '</b></a><br />';
				}
/*
				if (allowedTo('tp_gallery'))
					echo $bullet4.'<a href="' . $scripturl . '?action=tpmod;show=admin">' . $txt['permissionname_tp_gallery'] . '</a><br />';
				if (allowedTo('tp_teampage'))
					echo $bullet4.'<a href="' . $scripturl . '?action=tpmod;team=admin">' . $txt['permissionname_tp_teampage'] . '</a><br />';
				if (allowedTo('tp_linkmanager'))
					echo $bullet4.'<a href="' . $scripturl . '?action=tpmod;link=admin">' . $txt['permissionname_tp_linkmanager'] . '</a><br />';
*/
		}

         echo '</div>';

}
// category listing blocktype
function TPortal_categorybox()
{
    global $context, $settings, $options, $txt, $scripturl;

	if(isset($context['TPortal']['blockarticle_titles'][$context['TPortal']['blocklisting']])){
		echo '<div class="smalltext" ', (sizeof($context['TPortal']['blockarticle_titles'][$context['TPortal']['blocklisting']])>$context['TPortal']['blocklisting_height'] && $context['TPortal']['blocklisting_height']!='0') ? ' style="overflow: auto; width: 100%; height: '.$context['TPortal']['blocklisting_height'].'em;"' : '' ,'>';
		foreach($context['TPortal']['blockarticle_titles'][$context['TPortal']['blocklisting']] as $listing){
			if($listing['category']==$context['TPortal']['blocklisting'])
				echo '<b><a href="'.$scripturl.'?page='.$listing['id'].'">'.$listing['subject'].'</a></b> '.$txt[525].' '.$listing['poster'].'<br />';
		}
		echo '</div>';
	}
 }


?>